<?
function string_to_unixtime($string)
{
	$year = substr($string, 0, 4);
	$month = substr($string, 5, 2);
	$day = substr($string, 8, 2);
	$hour = substr($string, 11, 2);
	$minute = substr($string, 14, 2);
	$second = substr($string, 17, 2);
        return mktime($hour, $minute, $second, $month, $day, $year);
}
?>
<define-tag spokendate>
<?
  function spokendate ($date)
  {
    $mon = array ("January", "February", "March", "April", "May",
           "June", "July", "August", "September", "October", "November", "December");
    $rdate = explode ("-", $date);

    if (($rdate[2] % 10) == 1) {
      $appendix = "st";
    } elseif (($rdate[2] % 10) == 2) {
      $appendix = "nd";
    } elseif (($rdate[2] % 10) == 3) {
      $appendix = "rd";
    } else {
      $appendix = "th";
    }

    return (sprintf ("%s %d%s, %d", $mon[$rdate[1]-1], $rdate[2], $appendix, $rdate[0]));
  }
?>
</define-tag>

<define-tag insert_nili>
<?
  $days = array(
  "<iso-event-date-1>" => array(  "dinner" => "dinner-<iso-event-date-1>",
			  "sleeping" => "sleeping-<iso-event-date-1>"),
  "<iso-event-date_0>" => array(  "breakfast" => "breakfast-<iso-event-date_0>",
			  "dinner" => "dinner-<iso-event-date_0>",
			  "sleeping" => "sleeping-<iso-event-date_0>"),
  "<iso-event-date_1>" => array(  "breakfast" => "breakfast-<iso-event-date_1>",
			  "dinner" => "dinner-<iso-event-date_1>",
			  "sleeping" => "sleeping-<iso-event-date_1>"),
  "<iso-event-date_2>" => array(  "breakfast" => "breakfast-<iso-event-date_2>",
			  "dinner" => "dinner-<iso-event-date_2>",
			  "sleeping" => "sleeping-<iso-event-date_2>"),
  "<iso-event-date_3>" => array(  "breakfast" => "breakfast-<iso-event-date_3>",
			  "dinner" => "dinner-<iso-event-date_3>",
			  "sleeping" => "sleeping-<iso-event-date_3>"),
  "<iso-event-date_4>" => array(  "breakfast" => "breakfast-<iso-event-date_4>")
  );

  function insert_nili()
  {
	# Now add the new ones
	
	reset ($GLOBALS['days']);
	while (list($day,$value) = each($GLOBALS['days']))
	{
		$meals = array();
		
		reset ($value);
		while (list($meal,$variable) = each($value))
		{
			if ($GLOBALS[$variable] == 1) { $meals[$meal] = 1; }
		}

		if (($meals["breakfast"] != 0) || ($meals["dinner"] != 0) || ($meals["sleeping"] != 0)) {
		    $query = sprintf("INSERT INTO nili (person, date, breakfast, dinner, sleeping) " .
				 " VALUES ('%s', '%s', %d, %d, %d)", addslashes($GLOBALS['name']),
				 addslashes($day), $meals["breakfast"],
				 $meals["dinner"], $meals["sleeping"]);
		    pg_exec($GLOBALS['dbh'], $query) or die ("Cannot insert into nili");
		}
		
	}
  }
?>
</define-tag>

<define-tag randpass>
<?
  # This function is from phpdoc
  #
  function make_seed() {
      list($usec, $sec) = explode(' ', microtime());
      return (float) $sec + ((float) $usec * 100000);
  }

  function randpass()
  {
	  mt_srand(make_seed());
	  return substr(md5(mt_rand()), 0, 8);
  }

  function mail_password($email, $newpass)
  {
      if (strlen ($email) > 0) {
	  $body  = "LinuxTag Projects Management\n";
	  $body .= "<url-projects>\n\n";
	  $body .= "Account: " . $email . "\n";
	  $body .= "Password: " . $newpass . "\n";
	  $body .= "\nThe password may be changed within the system.\n";
	  $body .= "\nYou are subscribed to the infomails.\nYou can change this using the web interface.\n";
	  $body .= "\nThanks for your commitment.\n";
	  mail($email, "[LT Projects] New Password", $body, "From: joey@infodrom.org (LinuxTag Projects Management)");
      }
      return true;
  }
?>
</define-tag>

<define-tag job>
<?

function fragment_intro($fragmentid, $starttime, $endtime, $editable)
{
	?><hspace 30><?
	if ($editable == 1)
	{
	echo '<a href="edit_job_fragment.php3?id=' . $fragmentid . '">Edit</a> ';
	echo '<a href="assign_person.php3?fragmentid=' . $fragmentid . '">Assign</a> ';
	echo '<a href="update.php3?type=delete_job_fragment&id=' . $fragmentid . '">Delete</a>';
	}
	echo $starttime . ' - ' . $endtime . '<br>';
}

function job_assignment($fragmentid)
{
	global $dbh;
	$query = sprintf("SELECT *,oid from assignment where fragment = %d", $fragmentid);
	$sth = pg_exec($dbh, $query) or die ("Cannot execute query");
	if (pg_NumRows($sth) > 0)
	{
	?>
	<table cellpadding=0 cellspacing=1>
	<tr>
	<td width=60>&nbsp;</td>
	<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Name</b></font></td>
	<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Starttime</b></font></td>
	<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Endtime</b></font></td>
	<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Delete</b></font></td>
	<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Edit</b></font></td>
	</tr>
	<?
	for ($z = 0; $z < pg_NumRows($sth); $z++)
	{
		$row = pg_fetch_array($sth, $z);
		?>
		<tr><td width=60>&nbsp;</td>
		<td bgcolor="<cold>">
		<? echo $row['person']; ?>
		&nbsp;</td><td bgcolor="<cold>">
		<? echo $row['starttime']; ?>
		&nbsp;</td><td bgcolor="<cold>">
		<? echo $row['endtime']; ?>
		&nbsp;</td><td bgcolor="<cold>">
		<? echo "<a href=\"update.php3?type=delete_assignment&oid=" .
		        $row['oid'] . "\">delete</a>"; ?>
		</td><td bgcolor="<cold>">
		<? echo "<a href=\"assign_person.php3?fragmentid=" . $fragmentid . "&oid=" .
		        $row['oid'] . "\">edit</a>"; ?>
		</td></tr> <?
	}
	?>
	</table>
	<?
	}
}


function fragment_overview($fragmentid, $printall, $printassignment, $printedit)
{
	global $dbh;
	$changes = array();
	$query = sprintf("SELECT * from fragment where id = %d", $fragmentid);
	$sth = pg_exec($dbh, $query) or die ("DB");
	$fragment = pg_fetch_array($sth, 0) or die ("No Rows");
	
	if ($printall == 1)
	{
	fragment_intro($fragmentid, $fragment['starttime'], $fragment['endtime'], $printedit);
	}

	$changes[string_to_unixtime($fragment['starttime'])] = 0;

	$changes[string_to_unixtime($fragment['endtime'])] = 0;

	$query2 = sprintf("SELECT starttime, endtime from assignment where fragment = %d", $fragmentid);
	$sth2 = pg_exec($dbh, $query2) or die ("DB");

	for ($x = 0; $x < pg_NumRows($sth2); $x++)
	{
		$row = pg_fetch_array($sth2, $x);
		$changes[string_to_unixtime($row[0])]++;
		$changes[string_to_unixtime($row[1])] = $changes[string_to_unixtime($row[1])] - 1;
	}
	ksort($changes);
	list($oldkey, $oldchange) = each ($changes);
	$y = 0;
	for ($x = 0; $x < sizeof($changes) - 1; $x++)
	{
		list($key, $change) = each ($changes);
		if ($printall == 0)
		{
			// Check if we have to print
			if($fragment['min'] <= $oldchange)
			{
			$oldkey = $key;
			$oldchange = $change + $oldchange;
			continue;
			}
		}
		$y++;
		if ($y == 1)
		{
		if ($printall <> 1)
		{
		fragment_intro($fragmentid, $fragment['starttime'], $fragment['endtime'], $printedit);
		}
		?>
		<table cellpadding=0 cellspacing=1>
		<tr>
		<td width=60>&nbsp;</td>
		<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Time</font></b></td>
		<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Number of Supporters</font></b></td>
		<td bgcolor="<colh>"><font face="Helvetica,Arial"><b>Status</font></b></td>
		</tr>
		<?
		}
		
		?>
		<tr>
		<td>&nbsp;</td>
		<td bgcolor="<cold>">
		<? echo strftime("%Y-%m-%d %T", $oldkey) . " - " . strftime("%Y-%m-%d %T", $key); ?>
		</td>
		<td bgcolor="<cold>">
		<? echo $oldchange; ?>
		</td>
		<td bgcolor="<cold>">
		<?
		if ($fragment['min'] > $oldchange)
		{
			echo "Helpers missing";
		} else {
			echo "Helpers sufficient";
		}
		?>
		</td>
		</tr>
		<?
		$oldkey = $key;
		$oldchange = $change + $oldchange;
	}
	if ($y > 0)
	{
	?>
	</table>
	<?
	}

	if ($printassignment == 1)
	{
		job_assignment($fragmentid);
	}
}
?>
</define-tag>
